#include <stdio.h>
#include <string.h>

FILE *fp(), *infile, *outfile;
char nextword[200];
int newline=1, line_no = 1;
int ENGLISH=0;


void get_file_name(char arg1[], char arg2[])
{
   char infilename[20], outfilename[20];

   if (arg1 == NULL)
   {
      printf("Input file name : ");
      scanf("%s",infilename);
      sprintf(outfilename,"%s.html",infilename);
   }
   else
   {
      strcpy(infilename,arg1);
      if (arg2 == NULL)
         sprintf(outfilename,"%s.html",infilename);
      else
         strcpy(outfilename,arg2);
   }

   infile = fopen(infilename,"r");
   outfile = fopen(outfilename,"w");
}

void initialize()
{
   fprintf(outfile,"<HTML>\n");
   fprintf(outfile,"<HEAD>\n<TITLE>%s</TITLE>\n</HEAD>\n","Output of BW");
   fprintf(outfile,"<BODY BGCOLOR=#ffffff>\n");
   fprintf(outfile,"<FONT SIZE=+2>\n");
}

void conclude()
{
   fclose(infile);
   fprintf(outfile,"</FONT>\n");
   fprintf(outfile,"</BODY>\n");
   fprintf(outfile,"</HTML>\n");
   fclose(outfile);
}

void flush_previous_word()
{
   int i,j;

   for (i=0; i<200; i++) nextword[i]=0;
}

void read_next_word()
{
   char ch;
   int i,done;

   do
   {
      fscanf(infile,"%c",&ch);
      if (ch == '\n') 
      {
         line_no++;
         printf(".");fflush(stdout);
      }
   }  while ((!feof(infile))&&((ch==' ')||(ch=='\n')||(ch=='\t')));

   if (!feof(infile))
   {
      i = 0; nextword[i] = ch; done=0;
      do
      {
         fscanf(infile,"%c",&ch);
         done = ((ch==' ')||(ch=='\n')||(ch=='\t'));
         i++; if (!done) nextword[i] = ch;
         if (ch == '\n') 
         {
            line_no++;
            printf(".");fflush(stdout);
         }
      } while (!((feof(infile))||(done)));
   }
}

int vowel(c)
char c;
{
   return((c=='a')||(c=='e')||(c=='i')||(c=='o')||(c=='u')||(c=='R')||(c=='L'));
}

int punctuation(c)
char c;
{
   return((c=='H')||(c=='|')||(c=='!')||(c==':')||(c==',')||(c=='-')
           ||(c=='(')||(c==')')||(c=='.')||(c=='?')||(c=='"')||(c=='/')||
                                             (c=='\\')||(c=='_')||(c=='~'));
}

void put_punc_symb(c)
char c;
{
   switch(c)
   {
      case 'H':{fprintf(outfile,"<IMG SRC=banjon/H.gif>");break;}
      case '|':{fprintf(outfile,"<IMG SRC=misc/hasanta.gif>");break;}
      case '!':{fprintf(outfile,"<IMG SRC=punc/bang.gif>");break;}
      case ':':{fprintf(outfile,"<IMG SRC=punc/colon.gif>");break;}
      case ',':{fprintf(outfile,"<IMG SRC=punc/comma.gif>");break;}
      case '-':{fprintf(outfile,"<IMG SRC=punc/hyphen.gif>");break;}
      case '(':{fprintf(outfile,"<IMG SRC=punc/leftparen.gif>");break;}
      case ')':{fprintf(outfile,"<IMG SRC=punc/rightparen.gif>");break;}
      case '.':{fprintf(outfile,"<IMG SRC=punc/period.gif>");break;}
      case '?':{fprintf(outfile,"<IMG SRC=punc/question.gif>");break;}
      case '"':{fprintf(outfile,"<IMG SRC=punc/quote.gif>");break;}
      case '/':{fprintf(outfile,"<IMG SRC=punc/slash.gif>");break;}
      case '~':{fprintf(outfile,"<IMG SRC=misc/space.gif>");break;}
      case '\\':{fprintf(outfile,"<BR>");break;}
   }
}

int number(char c)
{
   return((c >= '0') && (c <='9'));
}

int exists_file(char directory[], char fname[])
{
   char command[100];

   sprintf(command,"test -e %s/%s.gif",directory,fname);
   return(!(system(command)));
}

void error_message(char sequence[])
{
   fprintf(outfile,"<IMG SRC=misc/error.gif>");
   printf("%s : undefined sequence in line %d\n",sequence,line_no);
}

void process_next_word(word)
char word[];
{
  char ban[40],swar[40],part[80];
  int length = strlen(word);
  int index = 0, i;

  for (i=0; i<40; i++)
  {
     ban[i] = 0; swar[i]= 0;
  }
  for (i=0; i<80; i++)
     part[i]= 0;


  if (ENGLISH)
  {
     if (strcmp(word,"</ENG>") != 0)
        fprintf(outfile,"%s",word);
     else
        ENGLISH = 0;
  }
  else
  {
   if (punctuation(word[index]))
   {
      put_punc_symb(word[index]); index++;
      if ((word[index-1]=='\\')&&(index==length)) newline=1;
   }
   else
   if (number(word[index]))
   {
      fprintf(outfile,"<IMG SRC=sankhya/%c.gif>",word[index]);
      index++;
   }
   else
   if (vowel(word[index]))
   {
      int i=0;

      do
      {
         swar[i] = word[index]; i++; index++;
      } while (vowel(word[index]));
      if (exists_file("swar",swar))
         fprintf(outfile,"<IMG SRC=swar/%s.gif>",swar);
      else
         error_message(swar);
   }
   else if (word[index] != EOF)
   {
      int i = 0, status = 0;

      if (word[index] == '<')
      {
         index++;
         while ((word[index] != '>') && (word[index] != 0) && (!(punctuation(word[index]))))
         {
            part[i] = word[index]; i++; index++;
         }
         if (word[index] == '>') index++;
         if ((strcmp(part,"ENG"))==0)
         {
            status = 3; ENGLISH = 1; 
         }
         else if (vowel(part[0]))
         {
            if (exists_file("swar",part))
               fprintf(outfile,"<IMG SRC=swar/%s.gif>",part);
            else
               error_message(swar);
         }
         else
            status = 2;
      }
      else
      {
         status = 1;
         while ((word[index] != 0) && (word[index] != '<') && 
               (!vowel(word[index])) && (!(punctuation(word[index]))) 
                                            && (!(number(word[index]))))
         {
            ban[i] = word[index]; i++; index++;
         }
      }
      if ((status == 1) || (status == 2))
      {
         i = 0;
         while (vowel(word[index]))
         {
            swar[i] = word[index];
            i++; index++;
         }
         if (!(exists_file("swar",swar)) && strcmp(swar,""))
            error_message(swar);
         else
         {
            if (strcmp(swar,"i") == 0) fprintf(outfile,"<IMG SRC=kar/i.gif>");
            if (strcmp(swar,"e") == 0) fprintf(outfile,"<IMG SRC=kar/e.gif>");
            if (strcmp(swar,"oi") == 0) fprintf(outfile,"<IMG SRC=kar/oi.gif>");
            if (strcmp(swar,"o") == 0) fprintf(outfile,"<IMG SRC=kar/e.gif>");
            if (strcmp(swar,"ou") == 0) fprintf(outfile,"<IMG SRC=kar/e.gif>");
   
            if (status == 1) 
            {
               int len = strlen(ban), chandrabindu = 0;
   
               if (ban[len - 1] == '^')
               {
                  chandrabindu = 1; ban[len - 1] = 0; len--;
               }

               if (len > 0) 
               {
                  if (exists_file("banjon",ban))
                     fprintf(outfile,"<IMG SRC=banjon/%s.gif>",ban);
                  else
                     error_message(ban);
               }
               if (chandrabindu)
                  fprintf(outfile,"<IMG SRC=banjon/^.gif>");
            }

            if (status == 2)
            {
               int ref = 0, jafala = 0, chandrabindu = 0, len = strlen(part);

               if (part[len - 1] == '^')
               {
                  chandrabindu = 1; part[len - 1] = 0; len--;
               }
               if (part[0] == 'r')
               {
                  ref = 1;
                  for (i = 0; i < len; i++) part[i] = part[i+1];
                  len--;
               }
               if (part[len - 1] == 'y')
               {
                  jafala = 1; part[len - 1] = 0; len--;
               }

               if (!((ref) || (jafala))) 
               {
                  if (exists_file("jukto",part))
                     fprintf(outfile,"<IMG SRC=jukto/%s.gif>",part);
                  else
                     error_message(part);
               }
               else
               {
                  if (exists_file("jukto",part))
                     fprintf(outfile,"<IMG SRC=jukto/%s.gif>",part);
                  else if (exists_file("banjon",part))
                     fprintf(outfile,"<IMG SRC=banjon/%s.gif>",part);
                  else
                     error_message(part);

                  if (ref) fprintf(outfile,"<IMG SRC=jukto/ref.gif>");
                  if (jafala) fprintf(outfile,"<IMG SRC=jukto/jafala.gif>");
               }
               if (chandrabindu) fprintf(outfile,"<IMG SRC=banjon/^.gif>");
            }
            if (strcmp(swar,"aa") == 0) fprintf(outfile,"<IMG SRC=kar/aa.gif>");
            if (strcmp(swar,"ee") == 0) fprintf(outfile,"<IMG SRC=kar/ee.gif>");
            if (strcmp(swar,"u") == 0) fprintf(outfile,"<IMG SRC=kar/u.gif>");
            if (strcmp(swar,"oo") == 0) fprintf(outfile,"<IMG SRC=kar/oo.gif>");
            if (strcmp(swar,"R") == 0) fprintf(outfile,"<IMG SRC=kar/R.gif>");
            if (strcmp(swar,"Ri") == 0) fprintf(outfile,"<IMG SRC=kar/R.gif>");
            if (strcmp(swar,"o") == 0) fprintf(outfile,"<IMG SRC=kar/aa.gif>");
            if (strcmp(swar,"ou") == 0) fprintf(outfile,"<IMG SRC=kar/ou.gif>");
         }
      }
   }

   if (index < length)
   {
      for (i = index; i <= length; i++) word[i - index] = word[i];
      process_next_word(word);
   }
  }
}
   
      

main(int argc,char *argv[])
{
   printf("\nBengali Writer version 1.4\n");
   printf("Copyright 1995 TBJS Software GmbH\n\n");
   get_file_name(argv[1],argv[2]);
   printf("doing ..");fflush(stdout);
   initialize();
   while (!feof(infile))
   {
      flush_previous_word();
      read_next_word();
      if (!(ENGLISH))
      {
         if (!(newline))
            fprintf(outfile,"\n<IMG SRC=misc/space.gif>\n");
         else
            fprintf(outfile,"\n");
         newline = 0;
      }
      else fprintf(outfile," ");
      if ((strcmp(nextword,"")) != 0)
         process_next_word(nextword);
   }
   conclude();
   printf("  done\n");
}

